org.scalatest

# TestFailedException

#### class TestFailedException extends StackDepthException with ModifiableMessage[TestFailedException]

Exception that indicates a test failed. The purpose of this exception is to encapsulate information about the stack depth at which the line of test code that failed resides, so that information can be presented to the user that makes it quick to find the failing line of test code. (In other words, the user need not scan through the stack trace to find the correct filename and line number of the failing test.)

Linear Supertypes
ModifiableMessage[TestFailedException], StackDepthException, StackDepth, RuntimeException, Exception, Throwable, Serializable, AnyRef, Any
Known Subclasses
GeneratorDrivenPropertyCheckFailedException, PropertyCheckFailedException, PropertyTestFailedException, TableDrivenPropertyCheckFailedException
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. TestFailedException
2. ModifiableMessage
3. StackDepthException
4. StackDepth
5. RuntimeException
6. Exception
7. Throwable
8. Serializable
9. AnyRef
10. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new TestFailedException (message: String, cause: Throwable, failedCodeStackDepth: Int)

   Create a `TestFailedException` with the specified stack depth, detail message, and cause.

   Create a `TestFailedException` with the specified stack depth, detail message, and cause.

   Note that the detail message associated with cause is not automatically incorporated in this throwable's detail message.

   message

     A detail message for this `TestFailedException`.

   cause

     the cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

2. #### new TestFailedException (cause: Throwable, failedCodeStackDepth: Int)

   Create a `TestFailedException` with the specified stack depth and cause.

   Create a `TestFailedException` with the specified stack depth and cause. The `message` field of this exception object will be initialized to `if (cause.getMessage == null) "" else cause.getMessage`.

   cause

     the cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

3. #### new TestFailedException (message: String, failedCodeStackDepth: Int)

   Create a `TestFailedException` with a specified stack depth and detail message.

   Create a `TestFailedException` with a specified stack depth and detail message.

   message

     A detail message for this `TestFailedException`.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

4. #### new TestFailedException (failedCodeStackDepth: Int)

   Create a `TestFailedException` with specified stack depth and no detail message or cause.

   Create a `TestFailedException` with specified stack depth and no detail message or cause.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

5. #### new TestFailedException (message: Option[String], cause: Option[Throwable], failedCodeStackDepth: Int)

   Constructs a `TestFailedException` with pre-determined `message` and `failedCodeStackDepth`.

   Constructs a `TestFailedException` with pre-determined `message` and `failedCodeStackDepth`. (This was the primary constructor form prior to ScalaTest 1.5.)

   message

     an optional detail message for this `StackDepthException`.

   cause

     an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

6. #### new TestFailedException (messageFun: (StackDepthException) ⇒ Option[String], cause: Option[Throwable], failedCodeStackDepthFun: (StackDepthException) ⇒ Int)

   messageFun

     a function that produces an optional detail message for this `TestFailedException`.

   cause

     an optional cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   failedCodeStackDepthFun

     a function that produces the depth in the stack trace of this exception at which the line of test code that failed resides.

### Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def canEqual (other: Any): Boolean

   Indicates whether this object can be equal to the passed object.

   Indicates whether this object can be equal to the passed object.

   Definition Classes
     TestFailedException → StackDepthException

8. #### def clone (): AnyRef

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()

9. #### def eq (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

10. #### def equals (other: Any): Boolean

    Indicates whether this object is equal to the passed object.

    Indicates whether this object is equal to the passed object. If the passed object is a `TestFailedException`, equality requires equal `message`, `cause`, and `failedCodeStackDepth` fields, as well as equal return values of `getStackTrace`.

    Definition Classes
      TestFailedException → StackDepthException → AnyRef → Any

11. #### def failedCodeFileName : Option[String]

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the filename that caused the failed test

    Definition Classes
      StackDepth

12. #### def failedCodeFileNameAndLineNumberString : Option[String]

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a user-presentable string containing the filename and line number that caused the failed test

    Definition Classes
      StackDepth

13. #### def failedCodeLineNumber : Option[Int]

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the line number that caused the failed test

    Definition Classes
      StackDepth

14. #### lazy val failedCodeStackDepth : Int

    The depth in the stack trace of this exception at which the line of test code that failed resides.

    The depth in the stack trace of this exception at which the line of test code that failed resides.

    One reason this is lazy is to delay any searching of the stack trace until it is actually needed. It will usually be needed, but not always. For example, exceptions thrown during a shrink phase of a failed property will often be `StackDepthException`s, but whose `failedCodeStackDepth` will never be used. Another reason is to remove the need to create a different exception before creating this one just for the purpose of searching through its stack trace for the proper stack depth. Still one more reason is to allow the message to contain information about the stack depth, such as the failed file name and line number.

    Definition Classes
      StackDepthException → StackDepth

15. #### def fillInStackTrace (): Throwable

    Definition Classes
      Throwable

16. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

17. #### def getCause (): Throwable

    Definition Classes
      Throwable

18. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

19. #### def getLocalizedMessage (): String

    Definition Classes
      Throwable

20. #### def getMessage (): String

    Returns the detail message string of this `StackDepthException`.

    Returns the detail message string of this `StackDepthException`.

    returns

      the detail message string of this `StackDepthException` instance (which may be `null`).

    Definition Classes
      StackDepthException → Throwable

21. #### def getStackTrace (): Array[StackTraceElement]

    Definition Classes
      Throwable

22. #### def hashCode (): Int

    Returns a hash code value for this object.

    Returns a hash code value for this object.

    Definition Classes
      TestFailedException → StackDepthException → AnyRef → Any

23. #### def initCause (throwable: Throwable): Throwable

    Attributes
      final
    Definition Classes
      StackDepthException → Throwable

24. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

25. #### lazy val message : Option[String]

    An optional detail message for this `StackDepth` exception.

    An optional detail message for this `StackDepth` exception.

    One reason this is lazy is to delay any searching of the stack trace until it is actually needed. It will usually be needed, but not always. For example, exceptions thrown during a shrink phase of a failed property will often be `StackDepthException`s, but whose `message` will never be used. Another related reason is to remove the need to create a different exception before creating this one just for the purpose of searching through its stack trace for the proper stack depth. Still one more reason is to allow the message to contain information about the stack depth, such as the failed file name and line number.

    Definition Classes
      StackDepthException → StackDepth

26. #### def modifyMessage (fun: (Option[String]) ⇒ Option[String]): TestFailedException

    Returns an instance of this exception's class, identical to this exception, except with the detail message option string replaced with the result of passing the current detail message to the passed function, `fun`.

    Returns an instance of this exception's class, identical to this exception, except with the detail message option string replaced with the result of passing the current detail message to the passed function, `fun`.

    fun

      A function that, given the current optional detail message, will produce the modified optional detail message for the result instance of `TestFailedException`.

    Definition Classes
      TestFailedException → ModifiableMessage

27. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

28. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

29. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

30. #### def printStackTrace (arg0: PrintWriter): Unit

    Definition Classes
      Throwable

31. #### def printStackTrace (arg0: PrintStream): Unit

    Definition Classes
      Throwable

32. #### def printStackTrace (): Unit

    Definition Classes
      Throwable

33. #### def setStackTrace (arg0: Array[StackTraceElement]): Unit

    Definition Classes
      Throwable

34. #### def severedAtStackDepth : TestFailedException

    Returns an exception of class `TestFailedException` with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off.

    Returns an exception of class `TestFailedException` with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off. This can be useful when working with tools (such as IDEs) that do not directly support ScalaTest. (Tools that directly support ScalaTest can use the stack depth information delivered in the StackDepth exceptions.)

    Definition Classes
      TestFailedException → StackDepth

35. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

36. #### def toString (): String

    Definition Classes
      Throwable → AnyRef → Any

37. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

38. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

39. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from ModifiableMessage[TestFailedException]

### Inherited from StackDepthException

### Inherited from StackDepth

### Inherited from RuntimeException

### Inherited from Exception

### Inherited from Throwable

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any